//############################################################
//#
//# expose.c
//# (c) Mark Ulrich june 2005
//# License: LGPL
//#
//############################################################


#include <X11/Xlib.h>
#include <Imlib2.h>
/* needed for sprintf and fprintf */
#include <stdio.h>
/* needed for getenv */
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

//void exposelist(void);

Display            *disp;
Window              win;
Visual             *vis;
Colormap            cm;
int                 depth;

XSetWindowAttributes attr;

   XEvent              ev;
   Imlib_Image         buffer;
   Imlib_Image         buffer2;
   Imlib_Image         image;
   Imlib_Image         mainimage;
   Imlib_Color_Range   range;
   Imlib_Font          font;
   char                text[4096];

int main(int argc, char **argv)
{


   const char         *display_name = getenv("DISPLAY");
   if (display_name == NULL)
       display_name = ":0";
   disp = XOpenDisplay(display_name);
   if (disp == NULL)
     {
       fprintf(stderr, "Can't open display %s\n", display_name);
       return 1;
     }

   vis = DefaultVisual(disp, DefaultScreen(disp));
   depth = DefaultDepth(disp, DefaultScreen(disp));
   cm = DefaultColormap(disp, DefaultScreen(disp));

int screen=DefaultScreen(disp);
int screenWidth=0;
int screenHeight=0;

screenWidth=XDisplayWidth(disp,screen);
screenHeight=XDisplayHeight(disp,screen);
int screenWidthold=screenWidth;
// --TEST --
//screenWidth=640;
//screenHeight=480;

//screenWidth=800;
//screenHeight=600;


//--- use just one monitor on dualscreensystems ---
if((float)screenWidth/screenHeight>2){
  screenWidth=screenWidth/2;
}

int w,h;

 attr.override_redirect=True;
 win=XCreateWindow(disp,DefaultRootWindow(disp),0,0,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
//   win = XCreateSimpleWindow(disp, DefaultRootWindow(disp),  0, 0, 640, 480, 0, 0, 0 );

   XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask |  PointerMotionMask | ExposureMask);

   XLowerWindow(disp, win);

   imlib_set_cache_size(2048 * 1024);
   /* set the font cache to 512Kb - again to avoid re-loading */
   imlib_set_font_cache_size(512 * 1024);

   imlib_set_color_usage(128);
   imlib_context_set_dither(1);
   imlib_context_set_blend(0);
   imlib_context_set_display(disp);
   imlib_context_set_visual(vis);
   imlib_context_set_colormap(cm);
   imlib_context_set_drawable(win);


//mainimage= imlib_create_image(screenWidth, screenHeight);
mainimage= imlib_load_image("background2.jpg");
   imlib_context_set_image(mainimage);
                mainimage = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() ,
                       screenWidth , screenHeight);
   imlib_context_set_image(mainimage);
   w = imlib_image_get_width();
   h = imlib_image_get_height();

   imlib_context_set_color(180, 180, 255, 255);

//   imlib_context_set_image(mainimage);
//   imlib_render_image_on_drawable(0, 0);

// -- colorrange for the textlabels --

             range = imlib_create_color_range();
             imlib_context_set_color_range(range);
             imlib_context_set_color(255, 255, 255, 255);
             imlib_add_color_to_color_range(0);
             /* add an orange color, semi-transparent 10 units from the first */
             imlib_context_set_color(255, 200, 10, 255);
             imlib_add_color_to_color_range(10);
             /* add black, fully transparent at the end 20 units away */
             imlib_context_set_color(90, 90, 0, 255);
             imlib_add_color_to_color_range(20);

//-- create background for textlabel
             buffer2 = imlib_create_image(screenWidth, 24);  
             imlib_context_set_image(buffer2);
             imlib_image_fill_color_range_rectangle(0,0, screenWidth, 30,  -45.0);

//-- create the font --
      //  font = imlib_load_font("notepad/10");
        font = imlib_load_font("Vera/10");

                  imlib_context_set_font(font);
                  imlib_context_set_color(0, 0, 0, 255);
                  imlib_context_set_font(font);
                  imlib_context_set_color(0, 0, 0, 255);

int x=0;
int y=0;

int cx=0;
int cy=0;
float ratio=0;
int ratioint=0;

int iconx=0;
int icony=0;
int iconw=0;
int iconh=0;

int iconsh[1000];
int iconsw[1000];

//char befehl[100];

int stored=0;
int stored2=0;
int stored3=0;

int counter=0;
int i=1;
int k=1;


///////////////////////////////////////////////////////////////////////////////////////////////////////////
// OPTIONS

int offset = 2;

int delay;
sscanf(argv[1], "%d", &delay); 
//printf("--%d--\n" ,delay);

int xcomp;
sscanf(argv[2], "%d", &xcomp); 
if(xcomp == 1){
  delay=0;
XMapWindow(disp,win);
XRaiseWindow(disp,win);
XFlush(disp);
}

   imlib_context_set_image(mainimage);
   imlib_render_image_on_drawable(0, 0);
int amount=0;

amount=(argc-1-offset)/2;

ratio=sqrt(amount);
ratioint=ratio;

cx=ratioint;
cy=ratioint;

if(ratio>ratioint){
    cx++;
}

//printf("ratio: %f\n" , ratio);

if(cx*cy<amount){
  cx++;
}

//printf("cx: %d\n" , cx);
//printf("cy: %d\n" , cy);

// ----------create images------------------------------------------------------------------

XWindowAttributes windowattr;
int windowid, thumbwidth, thumbheight ;
char *windowidstring;
int myfactor;


     Window junkwin;
     int rx,ry;
     int wasmoved = 0;

iconw=screenWidth/cx-10;
iconh=screenHeight/cy-10;
//printf( "IconBreite: %d Iconhhe: %d\n" ,iconw, iconh );
counter=0;
for(i=0;i<cx;i++){
  for(k=0;k<cy;k++){

    if(counter<argc-1-offset){
      counter+=1;
      //printf("row: %d col: %d id:%s name:%s\n" , i ,k, argv[counter+offset], argv[counter+1+offset]);

iconx=(screenWidth/cx) * i+5;
icony=(screenHeight/cy) * k+30;


//printf( "%d %d\n" ,iconx ,icony );

// ------ create thumbnail ----------------------------------------------------

sscanf(argv[counter+offset], "%x", &windowid);
thumbwidth=iconw;

//printf("------%x-------\n",windowid);



          windowidstring=argv[counter+offset];

        XGetWindowAttributes(disp, windowid, &windowattr);

     //--- absolute coordinates  


     XTranslateCoordinates (disp, windowid, windowattr.root, 
				-windowattr.border_width,
				-windowattr.border_width,
				&rx, &ry, &junkwin);

wasmoved = 0;
if( rx + windowattr.width >  screenWidthold){
  XMoveWindow(disp , windowid,0,0);
  XFlush(disp);
  wasmoved = 1;
usleep(900000);
}else{
if( ry + windowattr.height >  screenHeight){
  XMoveWindow(disp , windowid,0,0);
  XFlush(disp);
  wasmoved = 1;
usleep(900000);
}
}
if( rx < 0){
  XMoveWindow(disp , windowid,0,0);
  XFlush(disp);
  wasmoved = 1;
usleep(900000);
}else{
if( ry <0){
  XMoveWindow(disp , windowid,0,0);
  XFlush(disp);
  wasmoved = 1;
usleep(900000);
}
}

if (xcomp==0){
XMapWindow(disp,windowid);
XRaiseWindow(disp,windowid);
XFlush(disp);
usleep(delay);
}
imlib_context_set_drawable(windowid);

XMapWindow(disp,windowid);
//XRaiseWindow(disp,windowid);

        thumbheight = (int)((float)windowattr.height / ((float)windowattr.width/(float)thumbwidth));

if (thumbheight > thumbwidth){

  //printf("_%d\n" , thumbwidth);
  //printf("__%d\n" , thumbheight);

  myfactor = 10000*thumbwidth / thumbheight;
  thumbheight = thumbwidth;
  thumbwidth =  (int)thumbheight * myfactor/10000;

//  //printf("___%d\n" , myfactor);
//  //printf("ok\n");
}

iconsw[counter]=thumbwidth;
iconsh[counter]=thumbheight;

//--------------



        imlib_context_set_drawable(windowid);

	XSync(disp,True);


        if ( 4*thumbwidth >= windowattr.width || 2*thumbheight >= windowattr.height ) {
                image = imlib_create_image_from_drawable((Pixmap)0, 0, 0,
                        windowattr.width, windowattr.height, 1);
                imlib_context_set_image(image);
                image = imlib_create_cropped_scaled_image(0, 0, windowattr.width, windowattr.height,
                        thumbwidth, thumbheight);
        } else {
                image = imlib_create_scaled_image_from_drawable((Pixmap)0, 0, 0,
                        windowattr.width, windowattr.height, 4*thumbwidth, 2*thumbheight, 1, 1);
                imlib_context_set_image(image);
                image = imlib_create_cropped_scaled_image(0, 0, 4*thumbwidth, 2*thumbheight,
                        thumbwidth, thumbheight);
        }

        imlib_context_set_drawable(win);
        imlib_context_set_image(image);
if (xcomp==1){
        imlib_render_image_on_drawable(iconx, icony);
}
        imlib_context_set_image(mainimage);
                  imlib_blend_image_onto_image(image, 0, 0, 0, w, h,   iconx,icony, w, h);

imlib_context_set_image(image);
imlib_free_image();
      counter+=1;  
if(wasmoved == 1){
  XMoveWindow(disp, windowid,rx,ry);
}


XRaiseWindow(disp, win);
    }
  }
}	

  XRaiseWindow(disp, win);
  XMapWindow(disp, win);
        imlib_context_set_drawable(win);

        imlib_context_set_image(mainimage);
        imlib_render_image_on_drawable(0, 0);

XSync(disp,False);

   /* infinite event loop */
   for (;;)
     {


        /* while there are events form X - handle them */
        do
          {
             XNextEvent(disp, &ev);
             switch (ev.type)
               {

                 case ButtonPress:				
                          if(ev.xbutton.button==1)
				{
 
                         x = ev.xmotion.x;
                         y = ev.xmotion.y;
//printf("%d %d\n",x,y);


counter=0;
for(i=0;i<cx;i++){
  for(k=0;k<cy;k++){

    if(counter<argc-1-offset){
      counter+=1;
   //   //printf("row: %d col: %d id:%s name:%s\n" , i ,k, argv[counter+offset], argv[counter+1+offset]);

iconx=(screenWidth/cx) * i+5;
icony=(screenHeight/cy) * k+30;

if(x>iconx){
  if(x<iconx+iconsw[counter]){
    if(y>icony){
      if(y<icony+iconsh[counter]){
          sscanf(argv[counter+offset], "%x", &windowid);
          windowidstring=argv[counter+offset];


XMapWindow(disp,windowid);
XRaiseWindow(disp,windowid);
XFlush(disp);
exit(0);
          break;
      }
    }
  }

}

      counter+=1;
    }
  }
}


				}
                        if(ev.xbutton.button==3)
				{
                                    /* if we click anywhere in the window, exit */
                                   exit(0);
                                   break;
                                }

              case MotionNotify:
                    x = ev.xmotion.x;
                    y = ev.xmotion.y;

counter=0;
stored2=0;
for(i=0;i<cx;i++){
  for(k=0;k<cy;k++){

    if(counter<argc-1-offset){
      counter+=1;
   //   //printf("row: %d col: %d id:%s name:%s\n" , i ,k, argv[counter+offset], argv[counter+1+offset]);

iconx=(screenWidth/cx) * i+5;
icony=(screenHeight/cy) * k+30;


if(x>iconx){
  if(x<iconx+iconsw[counter]){
    if(y>icony){
      if(y<icony+iconsh[counter]){

stored3=0;

  stored2=1;
if(counter==stored){

  break;
}

stored=counter;

// -- create a descriptive textlabel --

  imlib_context_set_image(buffer2);
  buffer = imlib_clone_image();
      imlib_render_image_on_drawable(0,screenHeight-24 );
      imlib_render_image_on_drawable(0,0 );

  imlib_context_set_image(buffer);
 

                  imlib_context_set_font(font);
                  sprintf(text,argv[counter+1+offset]);
            imlib_text_draw(5,2,text);
        imlib_context_set_image(buffer);
        imlib_render_image_on_drawable(0, screenHeight-24);
        imlib_render_image_on_drawable(0,0 );

imlib_free_image();
imlib_free_font();
//printf("+++\n");
          break;
      }
    }
  }

}
      counter+=1;
    }
  }
}


// -- create an empty textlabel --
if(stored3==0){
if(stored2==0){
             imlib_context_set_image(buffer2);
             buffer = imlib_clone_image();
             imlib_render_image_on_drawable(0,screenHeight-24 );
             imlib_render_image_on_drawable(0,0 );
             imlib_context_set_image(buffer);
             imlib_free_image();
stored=0;
stored3=1;
//printf("---\n");
}
}


            //     default:
                    break;
               }                 

          }
        while (XPending(disp));

    }
 }


void exposelist(void){

  //printf("exposelist\n");


}
